
const replaceAll = (source, target, replaced) => {
  target = target.replace(new RegExp('\\$', "gm"), '\\$');
  console.log("replaceAll -> target", target)

  if (typeof (source) !== 'string') {
    throw new Error('ReplaceAll souce must be a string.');
  }
  return source.replace(new RegExp(target, "gm"), replaced);
}

const getDefaultValueFromConfig = (config) => {
  return converArrayToObject(config.filter(x => x.default !== undefined), 'key', 'default');
}

const converArrayToObject = (arr, key, valueKey = null) => {
  if (!valueKey)
    return arr.reduce((a, b) => ({ ...a, [b[key]]: b }), {});
  else
    return arr.reduce((a, b) => ({ ...a, [b[key]]: b[valueKey] }), {});
};

const converStringArrayToObject = (arr, value = (val) => val) => {
  return arr.reduce((a, b) => ({ ...a, [b]: value(b) }), {});
};

export {
  replaceAll,
  converArrayToObject,
  converStringArrayToObject,
  getDefaultValueFromConfig
}